#include <baseInternal.h>

#include <assert.h>
#include <stdlib.h>
#include <memory.h>

boolean slurpRangeOrigin(bigmem*M,const char* file, RangeOrigin*R){
	assert(R->start < R->end);
	return slurpSlice(M,file,R->start, R->end - R->start);
}

static boolean getRangeOrigin(RangeOrigin*R, const char*p){
	unsigned long l;
	char* r;

	R->start = R->end = 0;

	if ('#' == *p){
		p++;
	}
	l = strtoul(p, &r, 0);
	if (p == r){
		return false;
	}
	if (',' != *r++){
		return false;
	}
	while (' ' == *r) r++;
	if ('#' != *r++){
		return false;
	}
	p=r;
	R->start=l;
	l = strtoul(p, &r, 0);
	if (p == r || *r){
		return false;
	}
	R->end = l;
	return true;
}

boolean slurp(bigmem*M, const char* file){
	const char* p;
	RangeOrigin R;
	boolean status;
	char* f;

	p = strchr(file, ':');
	if (0 == p || !getRangeOrigin(&R, p+1)){
		return slurpExact(M,file);
	}

	f=xcopyn(file,p-file);
	status=slurpRangeOrigin(M,f,&R);
	xfree(f);
	return status;
}
