#include <base.h>
#include <assert.h>
#include <stdlib.h>
#include <memory.h>

void* xalloc(ul size){
	void* m;

	assert(size>0);
	m=malloc((size_t)size);
	assert(m);

	return m;
}

void* xrealloc(void*m, ul size){
	void* new_m;

	assert(size>0);
	/* palloc assumes this → assert(m); */
	
	new_m = realloc(m, size);
	assert(new_m);
	if (new_m != m){
		/* poison memory */
	}
	return new_m;
}

void xfree(void* v){
	assert(v);
	free(v);
}

void cxfree(void*v){
	if (!v){
		return;
	}
	xfree(v);
}

char* xcopy(const char*s){
	char* t;
	size_t l;

	l = strlen(s) + 1;
	t = xalloc(l);
	memcpy(t, s, l);

	return t;
}

char* cxcopy(const char*s){
	if(!s){
		return 0;
	}
	return xcopy(s);
}
	
char* xcopyn(const char*s, ul l){
	char* t;

	t = xalloc(l + sizeof('\0'));
	memcpy(t, s, l);
	t[l] = 0;

	return t;
}

void xreplace(char**t, const char*s){
	cxfree(*t);
	*t = xcopy(s);
}
