#!/usr/bin/awk --re-interval

# ya, unicode conversion in awk.

function p_rune(c,    a, b, x) {
	if (c <= 127){
		printf("%c", c);
		return;
	}

	if (c <= 2047){
		a = or(0xc0, rshift(c, 6));
		b = or(0x80, and(c, 255));
		printf("%c%c", a, b);
		return;
	}

	a = or(224, rshift(c, 12));
	b = or(0x80, and(rshift(c, 6), 63));
	x = or(0x80, and(c, 255));

	printf("%x\n", a);
	printf("%x\n", b);
	printf("%x\n", x);

	printf("%c%c%c", a, b, x);
}

{
	line = $0;

	
	for(i=1; (i = match(line, "\\\\u[0-9a-fA-F]{4}")); line = substr(line, i+6)) {
		printf("%s", substr(line, 1, i-1));
		r = strtonum("0x" substr(line, i+2, 4));
		p_rune(r);
	}
	if (length(line)) {
		print line;
	}
}
