typedef struct avlEntry avlEntry;

struct avlEntry {
	avlEntry* parent;
	avlEntry* left;
	avlEntry* right;
	char balance;

	void* data;
};

typedef struct {
	long n;
	const lstFns* f;
	avlEntry* head;
} avlHead;

avlHead* avlCreate(const lstFns*);
void avlDestroy(avlHead*);
avlHead* avlCopy(const avlHead*);

static inline long avlCount(const avlHead* a){
	return a->n;
}

static inline boolean avlEmpty(const avlHead* a){
	if (0 == avlCount(a)){
		return true;
	}
	return false;
}

static inline boolean avlZero(const avlHead* a){
	if (0 == a || avlEmpty(a)){
		return true;
	}
	return false;
}

void avlAddEntry(avlHead*, void*);

void avlDeleteEntry(avlHead*, avlEntry*);
boolean avlDeleteKey(avlHead*, const void*);

void* avlGetFirstData(const avlHead*, avlEntry**);
void* avlGetNextData(const avlHead*, avlEntry**);
void* avlGetLastData(const avlHead*, avlEntry**);
void* avlGetPrevData(const avlHead*, avlEntry**);

void** avl2tab(const avlHead*);
static inline void avlSort(avlHead*h) {USED(h);}		// compatability with lst.

avlEntry* avlScanForFn(const avlHead*, const void*, lstFnCompare);
avlEntry* avlScanFor(const avlHead*, const void*);
boolean avlInAvl(const avlHead*, const void*);

lstHead* avlToList(avlHead*);
lstHead* avlToStringList(avlHead*, const char*);
