/* field.h + slurp.h/getVal(); */
typedef enum {
	FExactZero,
	FExactEqual,
	FExactAnd,		/* v == (v&x) */
	FExactBitsSet,		/* v & x */
	FExactXor,		/* v ^ x */
	FExactInfinite
} FExact;

typedef struct Field Field;

typedef boolean (FieldCheck)(const Field*, unsigned long);

FieldCheck field_check_okay;	/* returns true */
FieldCheck field_check_all;
FieldCheck field_check_range;
FieldCheck field_check_exact;

FieldCheck field_check_re;

struct Field {
	int base;
	int nth;
	FieldCheck* check;	/* function */
	FExact exact_bit;	/* treatment of exact values */	
	int n_exact;		/* 0 → !exact */
	unsigned long mask;	/* for "exact" values */
	unsigned long* exact;	/* possible exact values */
	boolean has_min;
	unsigned long min;
	boolean has_max;
	unsigned long max;
	char* re;		/* and now for something completely different... */
	void* re_stuff;		/* actually a Regex* but you don't need to know that */
};

Field* fieldCreate(void);
Field* fieldCopy(const Field*);
lstHead* fieldCompile(Field*);
void fieldDestroy(Field*);

lstCmp fieldCmp(const Field*,const Field*);
extern const lstFns lstFnsField;

boolean getVal (bigmem*, Range*, unsigned long, char, char, int, unsigned long*);
boolean getVals(bigmem*, Range*, char, char, int, Field**, unsigned long*);
