#include <regex.h>

typedef struct {
	boolean iflag;
	lstHead* errors;
	struct re_pattern_buffer pbuf;
	struct re_registers regs;
	int nregs;
	regoff_t* starts;
	regoff_t* ends;
} Regex;

void regexInit(void);
Regex* regexCreate(void);
void regexDestroy(Regex*R);

boolean regexCompile(const char*, Regex*);
boolean regexMatchRange(Regex*, Range*);
boolean regexMatch(Regex*, const char*);
