/*
 * "quick string" -- eases parameter passing, but more importantly
 * saves "metadata" about the string (ie length and the hash).
 */

typedef struct {
	char * name;
	unsigned int len;
	unsigned int hash;
} qstr;

qstr* qstrCreate(void);
void qstrInit(qstr* qstr, const char* name, int len);	// name is stolen, not copied, despite "const"
qstr* qstrInst(const char* name, int len);		// ditto.
boolean qstreq(const qstr*, const qstr*);
lstCmp qstrCmp(const qstr*, const qstr*);		// doesn't do what you think
					// evaluates q1.hash <=> q2.hash
qstr* qstrCopy(const qstr*);
void qstrDestroy(qstr*);

extern const lstFns lstFnsQStr;
