typedef struct {
	char* m;
	size_t size;
	
	int fd;

	char* base;
	size_t base_size;
	size_t base_offset;
	boolean malloced;
} bigmem;

/* map copy-on-write buffer */
boolean slurpSliceFd(bigmem*, int, size_t, size_t);
boolean slurpSlice(bigmem*, const char*, size_t, size_t);
boolean slurpFd(bigmem*, int fd);
boolean slurpExact(bigmem*, const char*);
boolean slurp(bigmem*, const char*);		/* accepts file:#0,100 or just file */
void unslurp(bigmem*);

typedef struct {
	char* start;
	char* end;
} Range;

void rangeInit(Range*, void*, void*);

typedef struct {
	unsigned long start;
	unsigned long end;
} RangeOrigin;

void rangeOriginInit(RangeOrigin*, unsigned long, unsigned long);
RangeOrigin* rangeOrigin(RangeOrigin*, Range*, char*);

boolean slurpRangeOrigin(bigmem*,const char*, RangeOrigin*);

