/*
**
**  Classification:	UNCLASSIFIED
**
**  Copyright:		(c) Copyright 1997 Hoovers
**			This program is protected by the copyright law as an
**			unpublished work.
**
**  RCS Info:		$Date: 2005/05/29 17:02:16 $ $Revision: 1.1 $
**
**			$Id: stdprint.h,v 1.1 2005/05/29 17:02:16 quanstro Exp $
**
**  Filename:		$Source: /home/quanstro/src/elocate/include/RCS/stdprint.h,v $
**
**  Originator:		erik quanstrom
**			703 438 3500
**			quanstro@clark.net
**
**  Organization:	Hoovers
**			1761 Business Center Drive Suite 350
**			Reston, VA 20190
**			Ph: 703 438 3500  FAX: 703 438 3550
**
**  Description:
**
**	install standard type-based long formats:
**
**	%a.b{array}	Any**		a is elements, b is sizeof(element).
**	%{anonymous}	Formatlongconv	argument is an anonymous formatting fn.
**	%{avl %f}	avlHead*		avl tree.
**	%{base64}	char*		base-64 encoding
**	%{boolean}	boolean		"%{boolean}" → #t / #f; "%#{boolean}" → true / false
**	%{cquote}	char*		escapes nasty characters c-style.
**	%{dba_boolean}	dba_boolean	#t, #f, #n or with #, dba_true, etc.
**	%{env}		char*		environment variable as in "%{env}", "HOME" -> $HOME
**	%{field}		Field*		pretty print a field spec.
**	%{html}		char*		quote text for html; maybe this should be called %{hquote}
**	%{indent}			indent f->indent tabs.
**	%{list %f}	lstHead*		list (with optional member format %f, default is %s)
**	%{ltrim}  	char*		trims spaces off l side of %s argument
**	%{nsep <sep>}			set numeric seperator
**	%{qstr}		qstr*		just like %s.
**	%{rangeOrigin}	rangeOrigin*	print sam-compatable "#%d, #%d" byterange.
**	%{rcquote}	char*		quotes for rc -- including the 's -- if necessiary
**	%{rtrim}  	char*		trims spaces off r side of %s argument
**	%{sep <sep}			set char* sep
**	%{slurp}		char*		include file verbatim in format.
**	%{sqlquote}	char*		quote string for sql.
**	%{stuff}  	char*		xcharacter stuff string
**	%{time str}	time_t		defaulting to now (optional str as strftime())
**	%{timeval}	timeval*		 prints elapsed time.
**	%{trim}		char*		trims spaces off l and r side
**	%{unbase64}	char*		un-base-64 encoding
**	%{unhtml}	char*		turn html text into utf-8.
**	%{url}		char*		string printed as url
**
**  Limitations:
**
**	1.  linking against this library requires base,print,list,avl
**	2.  there aren't enough types represented here.
**	3.  maybe this should be rolled into the list library?
**
**  Modification History:
**
** 	15-jun-1998 quanstro Created.
**	01-oct-2005 quanstro updated comments.
**
******************************************************************************/
void stdprintInstall(void);
const char* stdprintVersion(void);
