/*  
** RCS Info:	$Date: 2005/06/04 08:01:53 $
**		$Id: vec.h,v 1.1 2005/06/04 08:01:53 quanstro Exp $
**		$Source: /home/quanstro/src/elocate/include/RCS/vec.h,v $
*/
typedef struct vecEntry vecEntry;
typedef struct vecHead  vecHead;

struct vecEntry {
	void* data;
};

struct vecHead {
	long n;
	long n_alloc;
	const lstFns* f;
	vecEntry* vec;
};

vecHead* vecCreate(const lstFns*);
void vecDestroy(vecHead*);
vecHead* vecCopy(const vecHead*);

static inline long vecCount(const vecHead* v){
	return v->n;
}

static inline boolean vecEmpty(const vecHead* v){
	if (0 == vecCount(v)){
		return true;
	}
	return false;
}

static inline boolean vecZero(const vecHead* v){
	if (0 == v || vecEmpty(v)){
		return true;
	}
	return false;
}

void vecAddEntry(vecHead *, void*);
//void vecPushEntry(vecHead *, void*);
void vecInsertEntry(vecHead*, vecEntry*, void*);

void vecRemoveEntry(vecHead*, vecEntry*);
void vecRemoveLast(vecHead*);
//void vecRemoveFirst(vecHead*);

vecEntry* vecGetFirst(const vecHead *);
vecEntry* vecGetLast(const vecHead *);
vecEntry* vecGetNext(const vecEntry *);
vecEntry* vecGetPrev(const vecEntry *);

void* vecGetFirstData(const vecHead*, vecEntry**);
void* vecGetNextData(const vecHead*, vecEntry**);
void* vecGetLastData(const vecHead*, vecEntry**);
void* vecGetPrevData(const vecHead*, vecEntry**);


void vecSort(vecHead*);

/* non-unicode bogosities */
//lstHead* lstStrstr2List(const char*, unsigned long, const char* );		/* seperators are list of char */
//lstHead* lstStr2List(const char*, const char* );		/* separator is 1 string */

vecEntry* vecScanForFn(const vecHead*, const void*, lstFnCompare);
vecEntry* vecScanFor  (const vecHead*, const void*);
boolean vecInList(const vecHead*, const void*);
