#include <lstInternal.h>

#define internal static

lstCmp xcmp(const char* a, const char*b){
	const char* ap;
	const char* bp;

	ap = a;
	bp = b;

	while (*ap == *bp){
		if (0 == *ap && 0 == *bp){
			return lstEqual;
		}
		ap++;
		bp++;
	}

	if (0 == *ap){
		return lstLess;
	}
	if (0 == *bp){
		return lstGreater;
	}
	
	if (*ap<*bp){
		return lstLess;
	}
	return lstGreater;
}

const lstFns lstFnsString = {
	(lstFnCopy)xcopy,
	xfree,
	(lstFnCompare)xcmp,
	"%s"
};

static const void* constxcopy(const void*p){
	return p;
}

static void constxfree(void*unused){
	USED(unused);
}

const lstFns lstFnsConstString = {
	(lstFnCopy)constxcopy,
	constxfree,
	(lstFnCompare)xcmp,
	"%s"
};
