#include <base.h>
#include <lst.h>
#include <print.h>
#include <xalloc.h>

#include <sys/types.h>
#include <dirent.h>
#include <errno.h>

static inline boolean bogus(const char* s){
	if ('.' == s[0] && (0 == s[1] || ('.' == s[1] && 0 == s[2]))){
		return true;
	}
	return false;
}

lstHead* getDirents(const char* name){
	DIR* D;
	struct dirent * e;
	int save_errno;
	lstHead* l;

	l = lstCreate(&lstFnsString);
	D = opendir(name);
	if (0 == D){
		fprint(2, "opendir(%r): %s\n", name);
		return l;
	}

	errno=0;
	while ((e=readdir(D))){
		if (bogus(e->d_name)){
			continue;
		}
		lstAddEntry(l, xcopy(e->d_name));
	}

	save_errno = errno;
	closedir(D);

	if (save_errno){
		errno=save_errno;
		fprint(2, "closedir(%r): %s\n", name);
	}

	return l;
}

