#include <mailhdr.h>
#include <stdprint.h>

#include <stdlib.h>
#include <unistd.h>
#include <string.h>

void printaddr(const char* s, int len, boolean fflag, boolean bflag){
	const char* sep = ", ";
	lstHead* l;

	l=str2mAddresses(s, len, 0);
	if (l->n) {
		if (fflag){
			if (bflag)	print("\t%/{list %#{mAddressBasic}}\n", sep, l);
			else	print("\t%/{list %#{mAddress}}\n", sep, l);
		} else {
			if (bflag)	print("\t%/{list %{mAddressBasic}}\n", sep, l);
			else	print("\t%/{list %{mAddress}}\n", sep, l);
		}
	}
	lstDestroy(l);
}

void convfd(int fd, boolean fflag, boolean bflag){
	char buf[4096*4];
	const char* bufp;
	const char* nl;
	long n;
	long n0;
	long l;

	bufp=buf;
	n=0;

	do {
	again:	n0 = read(fd, buf+n, 4096);
		if (-1 == n0){
			eprint("read: %r\n");
			exit(1);
		}
		for(n +=n0, bufp=buf; (nl = memchr(bufp, '\n', n)); n -=l+1, bufp = 1+nl){
			if (!nl && n0)
				goto again;
			l=nl-bufp;
			printaddr(bufp, l, fflag, bflag);
		}

		memmove(buf, bufp, n);
	} while (n0);
}

int main(int c __attribute__ ((unused)), char**v){
	boolean bflag;
	boolean fflag;
	boolean did;

	stdprintInstall();
	long_fmtinstall("mAddress", long_mAddress_conv);
	long_fmtinstall("mAddressBasic", long_mAddressBasic_conv);
	long_fmtinstall("atom", long_atom_conv);
	long_fmtinstall("fullatom", long_fullatom_conv);
	long_fmtinstall("phrase", long_phrase_conv);
	long_fmtinstall("fullphrase", long_fullphrase_conv);

	did = bflag = fflag = false;
	for(v++;*v;v++){
		if (0 == strcmp(*v, "-f")){
			fflag = true;
			continue;
		} else if (0 == strcmp(*v, "-b")){
			bflag = true;
			continue;
		}
		did = true;
		printaddr(*v, strlen(*v), fflag, bflag);
	}
	if (!did){
		convfd(0, fflag, bflag);
	}
	return 0;
}
