#include <mailhdr.h>
#include <sys/types.h>
#include <slurp.h>
#include <xalloc.h>

#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <assert.h>

lstHead* xform(lstHead* ls, const Xform* xform){
	USED(ls);
	USED(xform);
	assert(0 == "shouldn't be called");
	return 0;
}

boolean isdir(const char* path){
	struct stat st;

	if (-1 == stat(path, &st)) {
		return false;
	}
	if (S_IFDIR == (S_IFMT & st.st_mode)){
		return true;
	}
	return false;
}

boolean detach(const char* name, const char* body, int n){
	int fd;
	int w;

	fd = open(name, O_WRONLY|O_CREAT|O_TRUNC, 0666);
	if (-1 == fd){
		eprint("cannot open <%s>: %r\n", name);
		return false;
	}

	w = safe_write_all(fd, body, n);
	close(fd);

	if (-1 == w){
		eprint("cannot write <%s>: %r\n", name);
		return false;
	}
	return true;
}

void mboxDoc(const char* dir, mimeDoc* D){
	static const char* fmt = "%s/%ld.%04d_%04d";
	char filename[2048];
	mimeDoc* d;
	lstEntry* e;
	int t;
	static int n;
	int p;

	if (!D->subdocs){
		return;
	}

	t = time(0);
	p = getpid();

	for(d = lstGetFirstData(D->subdocs,&e); e; d = lstGetNextData(D->subdocs,&e)){
		snprint(filename, 2048, fmt, dir, t, n++, p);
		eprint("%s ... ", filename);
		detach(filename, d->body_in, d->n_in);
		eprint("%d bytes", d->n_in);
	}
}

int main(int c __attribute__ ((unused)), char**v){
	mimeDoc* D;
	bigmem M;
	const char* dir;

	mailprintInstall();
	dir = v[1];
	if (isdir(dir)){
		v++;
	} else {
		dir = getenv("m");
	}
	if (!dir){
		eprint("%s: $m is null\n");
	}

	for(v++;*v;v++){
		if (!slurp(&M, *v)){
			eprint("%s: %r\n", *v);
			exit(1);
		}
		D = mbox2mimeDoc(*v, M.m, M.size);
		if (!D){
			continue;
		}
		//print("%#{mimeDoc}\n", D);
		mboxDoc(dir, D);
		mimeDocDestroy(D);
	}
	return 0;
}
