#include <mailhdr.h>
#include <xalloc.h>

#include <memory.h>

nv* nvCreate(void){
	nv* n;

	n = xalloc(sizeof(nv));
	memset(n,0,sizeof(nv));
	return n;
}

nv* nvInst(char* name, char* value){
	nv* n;

	n = nvCreate();
	n->name = name;
	n->value = value;
	return n;
}

nv* nvCopy(const nv* n1){
	return nvInst(cxcopy(n1->name), cxcopy(n1->value));
}

void nvDestroy(nv* n){
	cxfree(n->name);
	cxfree(n->value);
	xfree(n);
}

const char* nvInTab(const char* name, const nv** v){
	for(; *v; v++){
		if (0 == strcasecmp(name, (*v)->name)){
			return (*v)->value;
		}
	}
	return 0;
}

fmt_action long_nv_conv(Format*f, const char* fmt){
	nv* n;
	USED(fmt);

	n = va_arg(f->args, nv*);
	if (!n){
		fmtprint(f, "(null)");
		return FMT_verb;
	}
	if (f->flags & FMT_altform){
	}

	fmtprint(f, "%s=%{atom}", n->name, n->value);
	return FMT_verb;
}

const lstFns lstFnsNv = {
	(lstFnCopy)nvCopy,
	(lstFnDelete)nvDestroy,
	0,
	"%{nv}"
};
