/*
 *	this is hopelessly archaic. we should be starting a writer and reader thread
 *	instead of this hideous read/write hang-o-matic loop.
*/

#include <mailhdr.h>
#include <print.h>
#include <xalloc.h>

#include <unistd.h>
#include <memory.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <fcntl.h>

enum { DELTA = 8 * 1024 };

// this looks like a dining philosopher's problem -- prone to lock up.
boolean runpipe(int pid, int* fd, const char* in, int in_len, char** out, ul* out_len){
	char* s;
	int salloc;
	int si;
	int bytes;
	boolean wdone;
	boolean rdone;
	int status;

	salloc = in_len + DELTA;
	si = 0;
	s = xalloc(salloc);

	wdone = false;
	rdone = false;

	do {
		if (!wdone){
			bytes = safe_write(fd[1], in, in_len);

			if (-1 == bytes){
				break;
			}
			if (0 == bytes){
				wdone=true;
				close(fd[1]);
			} else {
				in_len-=bytes;
				in+=bytes;
				if (0 == in_len){
					wdone=true;
					close(fd[1]);
				}
			}
		}

		if (!rdone){
			if (-1 == waitpid(pid, &status, WNOHANG)){
				rdone = true;
				break;
			}

			if (salloc-si < DELTA){
				s = xrealloc(s, salloc+=DELTA);
			}
			bytes = safe_read(fd[0], s + si, salloc-si);

			if (-1 == bytes){
				break;
			}
			if (0 == bytes){
				rdone=true;
			} else {
				si+=bytes;
			}
		}
	} while (!rdone || !wdone);

	if (rdone && wdone){
		*out = s;
		*out_len = si;
		return true;
	}
	xfree(s);
	return false;
}
