#include <mailhdr.h>
#include <stdprint.h>

#include <memory.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <fcntl.h>

const char* strstrn(const char* s, const char* find, int n){
	char* p;
	int l;
	int c;

	c = *find++;
	l = strlen(find);

	for (; n; s=p+1){
		p = memchr(s, c, n);
		if (!p)
			break;
		n -= p-s+1;
		if (n>=l && !memcmp(p+1, find, l)){
			return p;
		}
	}
	return 0;
}

void lowerString(char*s){
	if (!s){
		return;
	}

	while (*s){
		*s = tolower(*s);
		s++;
	}
}

void mailprintInstall(void){
	stdprintInstall();
	long_fmtinstall("head", long_head_conv);
	long_fmtinstall("headquote", long_headquote_conv);
	long_fmtinstall("mAddress", long_mAddress_conv);
	long_fmtinstall("mAddressBasic", long_mAddressBasic_conv);
	long_fmtinstall("mimeString", long_mimeString_conv);
	long_fmtinstall("mimeStringDispo", long_mimeStringDispo_conv);
	long_fmtinstall("mimeDoc", long_mimeDoc_conv);
	long_fmtinstall("un64", long_un64_conv);
	long_fmtinstall("unquoted_printable", long_unquoted_printable_conv);
	long_fmtinstall("atom", long_atom_conv);
	long_fmtinstall("fullatom", long_fullatom_conv);
	long_fmtinstall("phrase", long_phrase_conv);
	long_fmtinstall("fullphrase", long_fullphrase_conv);
	long_fmtinstall("nv", long_nv_conv);
	long_fmtinstall("strftime", long_strftime_conv);
}

int safe_write(int fd, const char* s, int len){
	int b;

again:	b = write(fd, s, len);
	if (-1 == b && errno == EINTR){
		goto again;
	}
	return b;
}

int safe_read(int fd, char* s, int len){
	int b;

again:	b = read(fd, s, len);
	if (-1 == b && errno == EINTR){
		goto again;
	}
	return b;
}

int safe_write_all(int fd, const char* s, int n){
	int bytes;
	int n0;

	n0 = n;
	while (n){
		bytes = safe_write(fd, s, n);
		if (-1 == bytes){
			return n0-n;
		}
		s += bytes;
		n -= bytes;
	}
	return n0;
}
