#include <stdprintInternal.h>
#include <lst.h>

#include <memory.h>

// print("%*.*{array %{field}}\n", sizeof(Field*), nfield, F);
// print("%*.{array %field}}\n", sizeof(Field*), F);			zero terminated
// print("%*.{array %d}\n", F);						zero terminated, default size int.

static unsigned long find_zero_bylong(const char* Ac){
	const long* A;
	const long* l;

	A=(long*)Ac;

	for(l=A; *l; l++){
	}
	return l-A;
}

static unsigned long find_zero_bychar(const char* A){
	const char*t;

	t=memchr(A,0,1<<31);
	if (0 == t){
		return 0;
	}
	return t-A;
}

static unsigned long find_zero(const char* A, int esize){
	const char*s;
	const char*z;
	int moddif;
	int i;

	for(s=A; ; s=z+esize){
		z=memchr(s, 0, 1<<31);
		if (0 == z){
			return 0;		/* good luck; i might as well core here */
		}
		moddif=(z-A)%esize;

		if (0 != moddif){
			z+= esize-moddif;
			continue;
		}
		for(i=0; i<esize; i++){
			if (z[i]){
				break;
			}
		}
		if (i == esize){
			return (z-A)/esize;
		}
	}
}

fmt_action long_array_conv(Format *f, const char* fmt){
	const char* A;
	int esize;
	int n;
	const char *s;
	const char *d;
	int i;

	A = va_arg(f->args, char*);
	esize = sizeof esize;

	if (f->flags & FMT_f1set){
		esize = f->f1;
	}
	if (f->flags & FMT_f2set){
		n = f->f2;
	} else {
		if (esize == sizeof(long)){
			n=find_zero_bylong(A);
		} else if (1 == esize){
			n=find_zero_bychar(A);
		} else {
			n=find_zero(A,esize);
		}
	}

	if (!A || esize<1 || n<=0){
		return FMT_verb;
	}

	if (f->client_data){
		d = (const char*)f->client_data;
	}else{
		d = ", ";
	}

	if (0 == fmt){
		fmt = "%s";
	}

	i=n;
	for (s = A; i--; s += esize){
		fmtprint(f,fmt,*(long*)s);
		if (i>0) fmtcat(f,d);
	}
	return FMT_verb;
}
