// c.f. list_conv.c
#include <stdprintInternal.h>
#include <lst.h>
#include <avlTree.h>

#define getFirst(a,b)	avlGetFirstData(a,b)
#define getNext(a,b)	avlGetNextData(a,b)

fmt_action long_avl_conv(Format *f, const char* fmt){
	avlHead* l;
	avlEntry* p;
	const char *s;
	const char *d;
	int i;

	l = va_arg(f->args, avlHead*);
	if (avlZero(l)){
		return FMT_verb;
	}

	if (f->client_data){
		d = (const char*)f->client_data;
	}else{
		d = ", ";
	}

	if (0 == fmt){
		fmt = l->f->print;
	}
	if (0 == fmt){
		fmt = "%s";
	}

	/* we don't trust people not to stick a null string in the list! */
	i=avlCount(l);
	for (s = getFirst(l,&p); --i; s=getNext(l,&p)){
		fmtprint(f,fmt,s);
		fmtprint(f,d);
	}
	fmtprint(f,fmt,s);

	return FMT_verb;
}
