#include <stdprintInternal.h>
#include <sys/types.h>
#include <slurp.h>
#include <lst.h>
#include <field.h>

#include <assert.h>

static char field_conv_bit(FExact f){
	char c;

	switch(f){
	case FExactInfinite:
	default:
		assert(0 == "bad value in field_conv_bit");
	case FExactZero:
		c = 0;
		break;
	case FExactEqual:
		c = '=';
		break;
	case FExactAnd:
		c = '&';
		break;
	case FExactBitsSet:
		return 's';
		break;
	case FExactXor:
		return 'x';
		break;
	}
	return c;
}

static fmt_action field_conv_arg(Format*f, Field*F){
	int i;

	fmtprint(f, "-f%uld", F->nth);
	if (F->base)	fmtprint(f, " -b%uld", F->base);
	if (F->has_min) fmtprint(f, " -m%uld", F->min);
	if (F->has_max)	fmtprint(f, " -M%uld", F->max);
	for (i=0; i<F->n_exact;i++){
		fmtprint(f, " -B%c%uld", field_conv_bit(F->exact_bit), F->exact[i]);
	}

	if (F->mask != ~0UL) fmtprint(f, " -X%uld", F->mask);
	if (F->re) fmtprint(f, " -r%{rcquote}", F->re); 
	return FMT_verb;
}

fmt_action long_field_conv(Format* f, const char*fmt){
	Field* F;
	USED(fmt);

	F = va_arg(f->args,Field*);
	if (0 == F) {
		return FMT_verb;
	}

	if (f->flags&FMT_altform){
		return field_conv_arg(f,F);
	} else {
		return field_conv_arg(f,F);
	}

	return FMT_verb;
}
