/*
**
**  Classification:	UNCLASSIFIED
**
**  Copyright:		(c) Copyright 1997 Hoovers
**			This program is protected by the copyright law as an
**			unpublished work.
**
**  RCS Info:		$Date: 2005/07/23 19:26:11 $ $Revision: 1.2 $
**
**			$Id: indent_conv.c,v 1.2 2005/07/23 19:26:11 quanstro Exp quanstro $
**
**  Filename:		$Source: /home/quanstro/src/elocate/stdprint/RCS/indent_conv.c,v $
**
**  Originator:		erik quanstrom
**			703 438 3500
**			quanstro@clark.net
**
**  Organization:	Hoovers
**			1761 Business Center Drive Suite 350
**			Reston, VA 20190
**			Ph: 703 438 3500	FAX: 703 438 3550
**
**  Description:
**
**	indent stuff n tabs
**
**  Limitations:
**
**	1.  none.
**
**  Modification History:
**
** 	21-jun-1998	quanstro Created.
**	02-jul-2005	quanstro use fmtpad().
**	01-oct-2005	quanstro use f->indent by default
**
******************************************************************************/
#include <stdprintInternal.h>
#include <string.h>

static void fmtpads(Format *format, SIZE_T len, const char* s) {
	int l;

	l = strlen(s);
	do; while (len-- != 0 && fmtappend(format, s, l));
}

fmt_action long_indent_conv(Format* f, const char* fmt){
	unsigned int i;
	const char* s;

	i = f->indent;
	if (f->flags & FMT_altform){
		i=va_arg(f->args,int);
	}
	s = "\t";
	if (fmt){
		s = fmt;
	}
	fmtpads(f, i, s);

 	return FMT_verb;
}
