/*
**
**  Classification:	UNCLASSIFIED
**
**  Copyright:		(c) Copyright 1997 Hoovers
**			This program is protected by the copyright law as an
**			unpublished work.
**
**  RCS Info:		$Date: 2005/07/23 19:13:50 $ $Revision: 1.5 $
**
**			$Id: list_conv.c,v 1.5 2005/07/23 19:13:50 quanstro Exp quanstro $
**
**  Filename:		$Source: /home/quanstro/src/elocate/stdprint/RCS/list_conv.c,v $
**
**  Originator:		erik quanstrom
**			703 438 3500
**			quanstro@clark.net
**
**  Organization:	Hoovers
**			1761 Business Center Drive Suite 350
**			Reston, VA 20190
**			Ph: 703 438 3500	FAX: 703 438 3550
**
**  Description:
**
**	print a list; arguments are used to format list members
**
**  Limitations:
**
**	1.  none?
**
**  Modification History:
**
** 	15-jun-1998 quanstro Created.
**	05-nov-1999 sward    Added anonymous format support.
**	21-jul-2005 quanstro Remove anonymous format support.
**
******************************************************************************/
#include <stdprintInternal.h>
#include <lst.h>

fmt_action long_list_conv(Format *f, const char* fmt){
	lstHead* l;
	lstEntry* p;
	const char *s;
	const char *d;
	int i;

	l = va_arg(f->args, lstHead*);
	if (lstZero(l)){
		return FMT_verb;
	}

	if (f->client_data){
		d = (const char*)f->client_data;
	}else{
		d = ", ";
	}

	if (0 == fmt){
		fmt = l->f->print;
	}
	if (0 == fmt){
		fmt = "%s";
	}

	/* we don't trust people not to stick a null string in the list! */
	i=lstCount(l);
	for (s = lstGetFirstData(l,&p); --i; s=lstGetNextData(l,&p)){
		fmtprint(f,fmt,s);
		fmtprint(f,d);
	}
	fmtprint(f,fmt,s);

	return FMT_verb;
}
