/*
**
**  Classification:	UNCLASSIFIED
**
**  Copyright:		(c) Copyright 1999 Hoovers
**			This program is protected by the copyright law as an
**			unpublished work.
**
**  RCS Info:		$Date: 2005/07/23 19:30:59 $ $Revision: 1.2 $
**
**			$Id: ltrim_conv.c,v 1.2 2005/07/23 19:30:59 quanstro Exp quanstro $
**
**  Filename:		$Source: /home/quanstro/src/elocate/stdprint/RCS/ltrim_conv.c,v $
**
**  Originator:		david sward
**			703 438 3500
**			sward@clark.net
**
**  Organization:	Hoovers
**			1761 Business Center Drive Suite 350
**			Reston, VA 20190
**			Ph: 703 438 3500	FAX: 703 438 3550
**
**  Description:
**
**	print the left-trimmed string
**
**  Limitations:
**
**	1.  none?
**
**  Modification History:
**
** 	27-jan-2000 sward    Created.
**
******************************************************************************/
#include <stdprintInternal.h>
#include <ctype.h>
#include <string.h>

fmt_action long_ltrim_conv(Format* f, const char*fmt){
	const char *str;
	SIZE_T l;
	USED(fmt);

	str = va_arg(f->args,char*);
	if (0 == str) {
		return FMT_verb;
	}

	if (f->flags & FMT_f2set){
		l = f->f2;
	} else {
		l = strlen(str);
	}

	/* ltrim */
	while (l && isspace(*str)) {
		str++; l--;
	}

	fmtappend(f,str,l);

	return FMT_verb;
}
