/*
**
** RCS Info:	$Date: 2005/08/04 01:40:12 $
**		$Id: strtob.c,v 1.1 2005/08/04 01:40:12 quanstro Exp quanstro $
**		$Source: /home/quanstro/src/elocate/base/RCS/strtob.c,v $
**
** Description:
**
**	quick strings. inspired by a linux kernel ds of the same name.
**
** Limitations:
**
**	1. ymmv with qstrCmp().
**	2. qstr_conv() should move to stdprint library?
**
** History:
**
**	07-aug-2005 quanstro created.
*/
#include <stdprintInternal.h>
#include <lst.h>
#include <qstr.h>

static inline SIZE_T min(SIZE_T a, SIZE_T b){
	if (a>b){
		return b;
	}
	return a;
}

// not utf-aware; but this is a byte-oriented deal anyway.
// bogusly stolen from print/sconv.c:sconv_bytes()
fmt_action long_qstr_conv(Format* f, const char* fmt){
	SIZE_T maxbytes, minwidth, extra;
	const qstr* q;
	USED(fmt);

	q = va_arg(f->args, qstr*);
	if (!q){
		fmtprint(f, "(null)");
		return FMT_verb;
	}

	if (f->flags & FMT_altform){
		fmtprint(f, "%uld:%#ulx:", q->len, q->hash);
		fmtappend(f, q->name, q->len);
		return FMT_verb;
	}

	if (f->flags & FMT_f2set){
		maxbytes=min(q->len, f->f2);
	} else {
		maxbytes = q->len;
	}

	minwidth = (f->flags & FMT_f1set) ? f->f1 : maxbytes;
	extra = (minwidth > maxbytes) ? minwidth - maxbytes : 0;

	if (f->flags & FMT_leftside) {
		fmtappend(f, q->name, maxbytes);
		fmtpad(f, extra, ' ');
	} else {
		fmtpad(f, extra, ' ');
		fmtappend(f, q->name, maxbytes);
	}
		
	return FMT_verb;
}

