/*
**
**  Classification:	UNCLASSIFIED
**
**  Copyright:		(c) Copyright 1997 Hoovers
**			This program is protected by the copyright law as an
**			unpublished work.
**
**  RCS Info:		$Date: 2005/07/01 17:43:21 $ $Revision: 1.3 $
**
**			$Id: stuff_conv.c,v 1.3 2005/07/01 17:43:21 quanstro Exp $
**
**  Filename:		$Source: /home/quanstro/src/elocate/stdprint/RCS/stuff_conv.c,v $
**
**  Originator:		erik quanstrom
**			703 849 1400
**			quanstro@clark.net
**
**  Organization:	Hoovers
**			7202 Arlington Blvd. Ste. 307
**			Reston, VA 20190
**			Ph: 703 849 1400	FAX: 703 849 9863
**
**  Description:
**
**	character-stuffed string %{stuff}
**
**  Limitations:
**
**	1.  none?
**
**  Modification History:
**
** 	14-dec-1998 quanstro Created.
**
******************************************************************************/
#include <stdprintInternal.h>
#include <xalloc.h>
#include <string.h>

static char* alt_stuff(const char* string, char badchar, long bytes, long* newsize){
        char* newstring;
        char* p;

        p = newstring = xalloc(bytes * 2 + 1);
	*newsize = 0;

	while (bytes--) {
                if (badchar == *string){
                        *p++ = badchar;
                }
                *p++ = *string++;
        }

	*p = 0;
	*newsize = p - newstring;

        return newstring;
}

fmt_action long_stuff_conv(Format* f, const char*fmt){
        char* string;
        char* value;
	char badchar;
	SIZE_T maxbytes;
	long newsize;

        string = va_arg(f->args,char*);
	if (fmt){
		badchar = *fmt;
	} else {
		badchar = '\'';
	}

        if (f->flags & FMT_altform) {
		maxbytes = (f->flags & FMT_f2set) ? f->f2 : strlen(string);
	} else {
		maxbytes = strlen(string);
		if ((f->flags & FMT_f2set) && (f->f2 < maxbytes)){
	    		maxbytes = f->f2;
		}
	}

	value = alt_stuff(string, badchar, maxbytes, &newsize);
        fmtappend(f,value,newsize);
	xfree(value);

        return FMT_verb;
}
