/*
**
**  Classification:	UNCLASSIFIED
**
**  Copyright:		(c) Copyright 1997 Hoovers
**			This program is protected by the copyright law as an
**			unpublished work.
**
**  RCS Info:		$Date: 2005/07/23 19:30:59 $ $Revision: 1.3 $
**
**			$Id: time_conv.c,v 1.3 2005/07/23 19:30:59 quanstro Exp quanstro $
**
**  Filename:		$Source: /home/quanstro/src/elocate/stdprint/RCS/time_conv.c,v $
**
**  Originator:		david sward
**			(703) 205-5999
**			sward@dev.k-link.com
**
**  Organization:	Hoovers
**			1761 Business Center Drive Suite 350
**			Reston, VA 20190
**			Ph: 703 438 3500	FAX: 703 438 3550
**
**  Description:
**
**	%{time}
**
**  Limitations:
**
**	1.  doesn't do tricks
**
**  Modification History:
**
**	13-aug-1998 sward Created.
**
******************************************************************************/
#include <stdprintInternal.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/time.h>

fmt_action long_time_conv(Format* fmt, const char* arg) {
	char out[100];
	struct tm *tm;
	time_t now;

	now = va_arg(fmt->args, time_t);
	if (0 == now) {
		now = time(0);
	}
	if (fmt->flags & FMT_altform) {
		tm = gmtime(&now);
	} else {
		tm = localtime(&now);
	}

	if (0 == arg) {
		/* Wed Aug 13 15:07:15 1998 EST */
		strftime(out, 99, "%a %b %e %H:%M:%S %Y %Z", tm);
	} else {
		strftime(out, 99, arg, tm);
	}

	fmtappend(fmt, out, strlen(out));
	return FMT_verb;
}
