/*
**
**  Classification:	UNCLASSIFIED
**
**  Copyright:		(c) Copyright 1997 Hoovers
**			This program is protected by the copyright law as an
**			unpublished work.
**
**  RCS Info:		$Date: 2005/07/19 03:53:00 $ $Revision: 1.3 $
**
**			$Id: timeval_conv.c,v 1.3 2005/07/19 03:53:00 quanstro Exp $
**
**  Filename:		$Source: /home/quanstro/src/elocate/stdprint/RCS/timeval_conv.c,v $
**
**  Originator:		david sward
**			(703) 849-9855
**			sward@dev.k-link.com
**
**  Organization:	Hoovers
**			1761 Business Center Drive Suite 350
**			Reston, VA 20190
**			Ph: 703 438 3500	FAX: 703 438 3550
**
**  Description:
**
**	print a timeval
**
**  Limitations:
**
**	1.  
**
**  Modification History:
**
** 	12-aug-1998 sward    Created.
**	22-mar-1999 quanstro nt port
**	14-jul-1999 sward    Fixed some goofy behavior.
**	01-jul-2005 quanstro uh, boolean.
**
******************************************************************************/
#include <stdprintInternal.h>
#include <memory.h>
#include <time.h>
#include <sys/time.h>

static void assign_time(struct timeval* dest, struct timeval* source) {
	if (source) {
		dest->tv_sec = source->tv_sec;
		dest->tv_usec = source->tv_usec;
	} else {
		gettimeofday(dest, 0);
	}
}

fmt_action long_timeval_conv(Format* fmt, const char* arg) {
	struct timeval* tv;
	struct timeval now;
	struct timeval earlier;
	struct timeval later;
	int ldig = 0;
	int rdig = 3;
	boolean f1ok = true;
	boolean f2ok = true;
	USED(arg);

	ldig=0;
	rdig=3;
	f1ok = true;
	f2ok = true;

	tv = va_arg(fmt->args, struct timeval*);
	if (fmt->flags & FMT_f1set) {
		ldig = fmt->f1;
	}
	if (fmt->flags & FMT_f2set) {
		rdig = fmt->f2;
	}

	if (fmt->flags & FMT_altform) {
		/* elapsed time ...

		from client_data to present
			print("%/#{timeval}", &in_the_past, 0);

		from client_data/present to future/tv

			print("%#{timeval}", &in_the_future);
			print("%/#{timeval}", 0, &in_the_future);
			print("%/#{timeval}", &start_time, &end_time);
		*/

		assign_time(&earlier, fmt->client_data);
		assign_time(&later, tv);

		now.tv_sec = later.tv_sec - earlier.tv_sec;
		now.tv_usec = later.tv_usec - earlier.tv_usec;
		if (now.tv_usec < 0) {
			now.tv_sec--;
			now.tv_usec += 1000000;
		}
	} else {
		/* exact time */

		assign_time(&now, tv);
	}

	if (ldig < 0) ldig = 0;
	if (rdig > 6) rdig = 6;
	if (rdig < 0) rdig = 0;

	if (fmt->flags & FMT_f1set && 0 == ldig) {
		f1ok = false;
	}
	if (fmt->flags & FMT_f2set && 0 == rdig) {
		f2ok = false;
	}

	if (f1ok) {
		if (fmt->flags & FMT_zeropad) {
			fmtprint(fmt, "%0*d", ldig, now.tv_sec);
		} else {
			fmtprint(fmt, "%*d", ldig, now.tv_sec);
		}
	}
	if (f1ok && f2ok) {
		fmtputc(fmt, '.');
	}
	if (f2ok) {
		int cdig, fact;
		for (fact = 1, cdig = 6 - rdig; cdig; cdig--) {
			fact *= 10;
		}
		now.tv_usec /= fact;

		fmtprint(fmt, "%0*d", rdig, now.tv_usec);
	}
	return FMT_verb;
}
